{---------------------------------------------------------------------------}
{                           DEMOCOM.PAS                                     }
{---------------------------------------------------------------------------}

program DEMOCOM;

uses crt,comlib;

type string2=string[2];


var
  fin     :boolean;
  touche  :char;
  n       :word;
  m       :word;
  carrecu :char;
  car     :char;
  numcom  :word;
  err     :word;
  br      :word;
  p       :char;
  ws      :word;
  sb      :word;
  bs      :word;
(****************************************************************************)
function hex(ad:byte):string2;

const lettre:array[0..15] of char ='0123456789ABCDEF';
begin
     hex:=(lettre[ad shr 4]+lettre[ad and $0f]);
end;


(****************************************************************************)



{---------------------------------------------------------------------------}

procedure TestErreur;

begin
  err:=comresult;
  gotoxy(1,10);
  writeln('ComResult=',Err);
  if Err<>0
    then
      begin
        case err of
          1 :writeln('Tentative de lecture d''un port serie vide.');
          2 :writeln('TIMEOUT. Impossible d''mettre le caractre demand.');
          3 :writeln('Le port est ouvert.');
          4 :writeln('Le port est ferm.');
          5 :writeln('Erreur dans le N du port (1 ou 2).');
          6 :writeln('Port non install sur la machine.');
          7 :writeln('Vitesse demande incorrcte.');
          8 :writeln('Erreur dans la parit demande.');
          9 :writeln('Longueur non conforme  la liste (7 ou 8)');
          10:writeln('Nombre de bits de stop incorrect (1 ou 2)');
          11:writeln('Erreur dans la taille du buffer (10  65500)');
          12:writeln('Pas assez de place en mmoire pour crer le buffer.');
        end;
      end;
end;
{---------------------------------------------------------------------------}

begin
  clrscr;
  NumCom:=1;
  br:=1200;
  p:='A';
  ws:=8;
  sb:=2;
  bs:=10000;
  OpenCom(Numcom,br,p,ws,sb,bs);

  fin:=false;
  repeat
  window(1,1,80,25);
  clrscr;
  writeln('1 - Envoi d''une chaine de test vers le COM',NumCom,'.');
  writeln('2 - Lecture du COM',NumCom,'.');
  writeln('3 - Envoi de caractres vers le COM',Numcom,'.');
  writeln('4 - Changement de port.');
  writeln('5 - Configuration du port COM',NumCom,'.');
  writeln('ESC pour terminer');
  write('--------------------------------------------------------------------------------');
  write(br,' Bauds, Parit "',p,'" ',ws,' Bits de donnes, ',sb, ' bit');
  if sb>1 then write('s');
  writeln(' stop, buffer de ',bs, ' octets');
  write('--------------------------------------------------------------------------------');
  TestErreur;
  gotoxy(1,12);
  write('--------------------------------------------------------------------------------');
  gotoxy(56,6);
  write('Choix -> ');
  repeat
    touche:=readkey;
  until touche in[#$1B,'1'..'6'];
  writeln;
  writeln;
  case touche of
    '1'  : begin
      window(1,13,80,25);
      clrscr;
      writeln('Envoi en cours...');
      ComOutStr(NumCom,#12#20);
      for n:=1 to 5 do
        begin
          for m:=32 to 127 do
            ComOutChar(NumCom,chr(m));
          ComOutStr(NumCom,#13#10);
        end;
      end;

    '2'  :begin
            window(1,13,80,25);
            clrscr;
            writeln('Appuyer sur ESC pour arreter la reception.');
            clrscr;
            repeat
              if ComInReady(NumCom)
                then
                  begin

                    carrecu:=ComInChar(NumCom);

                    write(hex(ord(carrecu)),' ');
                  end
            until not cominready(numcom);
            writeln;
            writeln('Fin de transmission, appuyer sur ENTREE.');
            readln;
          end;
    '3'   :begin
             window(1,13,80,25);
             clrscr;
             writeln('Entrer le texte  envoyer vers le minitel (Esc pour finir).');
             repeat
               car:=readkey;
               if car<>#27
                 then ComOutChar(NumCom,car);
             until car=#27;
           end;
    '4'    :begin
              CloseCom(NumCom);
              window(1,13,80,25);
              clrscr;
              write('N du nouveau port : ');
              readln(NumCom);
              OpenCom(NumCom,br,p,ws,sb,bs);
            end;
    '5'     :begin
               CloseCom(Numcom);
               window(1,13,80,25);
               clrscr;
               write('Vitesse (50  19200)              :');
               readln(br);
               write('Parit (P,I,A,M,S)                :');
               readln(p);
               write('Longueur des donnes (5  8)      :');
               readln(ws);
               write('Nombre de bits de stop (1 ou 2)   :');
               readln(sb);
               write('Taille du buffer (  65500)       :');
               readln(bs);
               OpenCom(NumCom,br,p,ws,sb,bs);
             end;
     '6'    :begin
               window(1,13,80,25);
               clrscr;

               if Cominready(numcom)
                 then writeln('Caractre  lire.')
                 else writeln('Buffer vide.');
             end;


    #$1B:fin:=true;
   end;
  until fin;
  clrscr;
  CloseCom(NumCom);
end.
